/**
 * Scattering intensity for dispersed [PYTHONCLASS]
 * 
 * WARNING: THIS FILE WAS GENERATED BY IGORGENERATOR.PY
 *          DO NOT MODIFY THIS FILE, MODIFY [INCLUDE_FILE]
 *          AND RE-RUN THE GENERATOR SCRIPT
 *
 * This code was written as part of the DANSE project
 * http://danse.us/trac/sans/
 *
 * Copyright 2007: University of Tennessee, for the DANSE project
 */

#include "[INCLUDE_FILE]"
#include <math.h>
#include "libCylinder.h"
#include "libSphere.h"
#include "c_disperser.h"

/**
 * Function to evaluate 2D scattering function
 * 
 * @param dp: parameters of the function
 * @param q: q-value
 * @param phi: angle of the q-vector in the plane of the detector, relative to q_x
 * @return: function value
 */
double oriented_[C_FILENAME]_2D(double pars[], double q, double phi) {
	[MODELSTRUCT] danse_pars;
	
[BINDINGS]
	return [C_FILENAME]_analytical_2D(&danse_pars, q, phi);		
}
	
/**
 * Function to evaluate dispersed 2D scattering function
 * 
 * @param dp: parameters of the function
 * @param q: q-value
 * @param phi: angle of the q-vector in the plane of the detector, relative to q_x
 * @return: function value
 * 
 [PARS_LIST]
 */
double disperse_[C_FILENAME]_analytical_2D(double dp[], double q, double phi) {
	int paramList[[NDISPERSE]];
	double sigmaList[[NDISPERSE]];
	int npts;
	int i;
	double pars[[NPARS]];
	
[DISPERSE]

	// Internal copy of parameters
	for(i=0; i<[NPARS]; i++ ) {
		pars[i] = dp[i];
	}

	return c_disperser( &oriented_[C_FILENAME]_2D, pars, [NDISPERSE], 
					paramList, sigmaList, npts, q, phi ); 

	
}
    